<template>
  <base-modal :is-open="showForm" class="feedback-form" @close="closeForm">
    <template #main>
      <div class="feedback-form__wrap">
        <form ref="form">
          <p class="feedback-form__title">Contacts Us</p>
          <base-input-black
            v-model="name"
            name="name"
            class="feedback-form__input"
            :label="'Name *'"
            placeholder="Name *"
            :invalid="nameInvalid"
            @input="nameInvalid = false"
            required-field
          />
          <base-input-black
            v-model="email"
            name="email"
            class="feedback-form__input"
            :label="'Email *'"
            placeholder="Email *"
            :invalid="emailInvalid"
            @input="emailInvalid = false"
            required-field
          />
          <base-input-black
            v-model="phone"
            name="phone"
            class="feedback-form__input"
            :label="'Phone *'"
            placeholder="Phone *"
            :invalid="phoneInvalid"
            @input="phoneInvalid = false"
            required-field
          />
          <!--
            <base-input-phone v-model='phone' name='phone' class='feedback-form__phone' :label='"Phone *"' :invalid='phoneInvalid' @input='phoneInvalid = false' required-field/>
-->
          <div class="feedback-form__services">
            <p>Services</p>
            <div class="feedback-form__services-list">
              <base-radio-button
                v-model="services"
                name="services"
                label="TBCC Cloud"
                value="TBCC Cloud"
              />
            </div>
          </div>
          <base-textarea
            v-model="message"
            name="message"
            class="feedback-form__message"
            :label="'Message'"
            placeholder="Message"
            rows="2"
          />
        </form>
      </div>
    </template>
    <template #footer>
      <base-button shaded class="feedback-form__btn" @click.native="send">
        Submit
      </base-button>
    </template>
  </base-modal>
</template>
<script>
import emailjs from '@emailjs/browser'
import { mapActions, mapGetters } from 'vuex'
import BaseModal from '../base/BaseModal'
import BaseButton from '../base/BaseButton'
import BaseInputBlack from '../base/BaseInputBlack'
import BaseRadioButton from '../base/BaseRadioButton'
import BaseTextarea from '../base/BaseTextarea'
export default {
  components: {
    BaseTextarea,
    BaseRadioButton,
    BaseInputBlack,
    BaseButton,
    BaseModal,
  },
  data() {
    return {
      open: true,
      name: '',
      nameInvalid: false,
      email: '',
      emailInvalid: false,
      phone: '',
      phoneInvalid: false,
      services: 'TBCC Cloud',
      message: '',
    }
  },

  computed: {
    ...mapGetters({
      showForm: 'getFeedbackForm',
    }),
  },

  methods: {
    ...mapActions({
      toggleShowForm: 'toggleShowFeedbackForm',
    }),

    closeForm() {
      this.toggleShowForm(false)
      this.open = ''
      this.name = ''
      this.email = ''
      this.phone = ''
      this.services = 'TBCC Cloud'
      this.message = ''
    },

    async send() {
      let valid = true
      if (this.name.length === 0) {
        this.nameInvalid = true
        valid = false
      }
      if (this.email.length === 0) {
        this.emailInvalid = true
        valid = false
      }
      if (this.phone.length < 4) {
        this.phoneInvalid = true
        valid = false
      }
      if (valid) {
        await emailjs
          .sendForm(
            'service_3v116fc',
            'template_qgu1ytd',
            this.$refs.form,
            'XzophZNPxXf0oQgPq'
          )
          .then(
            (result) => {
              console.log('SUCCESS!', result.text)
            },
            (error) => {
              console.log('FAILED...', error.text)
            }
          )
        this.closeForm()
      }
    },
  },
}
</script>

<style lang="scss" scoped>
.feedback-form {
  &__wrap {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 380px;

    @media (max-width: 767px) {
      width: 280px;
    }

    form {
      display: flex;
      flex-direction: column;
      align-items: center;
    }
  }

  &__title {
    font-weight: 700;
    font-size: 28px;
    color: #ffffff;
    margin: 0 0 35px;

    @media (max-width: 767px) {
      margin: 0 0 15px;
    }
  }

  &__input,
  &__phone,
  &__message {
    width: 340px;

    @media (max-width: 767px) {
      width: 280px;
    }
  }

  &__input {
    margin-bottom: 10px;
  }

  &__phone {
    margin-top: 30px;
    margin-bottom: 30px;

    @media (max-width: 767px) {
      margin-top: 25px;
      margin-bottom: 25px;
    }
  }

  &__services {
    width: 100%;
    margin-bottom: 10px;
    p {
      font-weight: 300;
      font-size: 16px;
      color: rgba(255, 255, 255, 0.45);
    }
  }

  &__services-list {
    display: flex;

    & > label:first-child {
      margin-right: 17px;
    }
  }

  &__message {
    margin-bottom: 20px;
  }

  &__btn {
    justify-content: center;
    width: 100%;
  }
}
</style>

<style lang="scss">
.feedback-form {
  .modal {
    background: #0e1b4e;
    padding: 35px 30px 35px;
    border-radius: 24px;

    @media (max-width: 767px) {
      padding: 25px 30px 25px;
    }
  }
}
</style>
